diff --git a/gcc/testsuite/gcc.target/riscv/sat_arith.h b/gcc/testsuite/gcc.target/riscv/sat_arith.h
index cf055410fd1..91853b60f59 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_arith.h
+++ b/gcc/testsuite/gcc.target/riscv/sat_arith.h
@@ -218,40 +218,40 @@ sat_u_sub_##T##_fmt_12 (T x, T y)                      \
 /* Saturation Truncate (unsigned and signed)                                  */
 /******************************************************************************/
 
-#define DEF_SAT_U_TRUC_FMT_1(NT, WT)     \
+#define DEF_SAT_U_TRUNC_FMT_1(NT, WT)    \
 NT __attribute__((noinline))             \
-sat_u_truc_##WT##_to_##NT##_fmt_1 (WT x) \
+sat_u_trunc_##WT##_to_##NT##_fmt_1 (WT x) \
 {                                        \
   bool overflow = x > (WT)(NT)(-1);      \
   return ((NT)x) | (NT)-overflow;        \
 }
-#define DEF_SAT_U_TRUC_FMT_1_WRAP(NT, WT) DEF_SAT_U_TRUC_FMT_1(NT, WT)
+#define DEF_SAT_U_TRUNC_FMT_1_WRAP(NT, WT) DEF_SAT_U_TRUNC_FMT_1(NT, WT)
 
-#define DEF_SAT_U_TRUC_FMT_2(NT, WT)     \
+#define DEF_SAT_U_TRUNC_FMT_2(NT, WT)    \
 NT __attribute__((noinline))             \
-sat_u_truc_##WT##_to_##NT##_fmt_2 (WT x) \
+sat_u_trunc_##WT##_to_##NT##_fmt_2 (WT x) \
 {                                        \
   WT max = (WT)(NT)-1;                   \
   return x > max ? (NT) max : (NT)x;     \
 }
-#define DEF_SAT_U_TRUC_FMT_2_WRAP(NT, WT) DEF_SAT_U_TRUC_FMT_2(NT, WT)
+#define DEF_SAT_U_TRUNC_FMT_2_WRAP(NT, WT) DEF_SAT_U_TRUNC_FMT_2(NT, WT)
 
-#define DEF_SAT_U_TRUC_FMT_3(NT, WT)     \
+#define DEF_SAT_U_TRUNC_FMT_3(NT, WT)    \
 NT __attribute__((noinline))             \
-sat_u_truc_##WT##_to_##NT##_fmt_3 (WT x) \
+sat_u_trunc_##WT##_to_##NT##_fmt_3 (WT x) \
 {                                        \
   WT max = (WT)(NT)-1;                   \
   return x <= max ? (NT)x : (NT) max;    \
 }
-#define DEF_SAT_U_TRUC_FMT_3_WRAP(NT, WT) DEF_SAT_U_TRUC_FMT_3(NT, WT)
+#define DEF_SAT_U_TRUNC_FMT_3_WRAP(NT, WT) DEF_SAT_U_TRUNC_FMT_3(NT, WT)
 
-#define RUN_SAT_U_TRUC_FMT_1(NT, WT, x) sat_u_truc_##WT##_to_##NT##_fmt_1 (x)
-#define RUN_SAT_U_TRUC_FMT_1_WRAP(NT, WT, x) RUN_SAT_U_TRUC_FMT_1(NT, WT, x)
+#define RUN_SAT_U_TRUNC_FMT_1(NT, WT, x) sat_u_trunc_##WT##_to_##NT##_fmt_1 (x)
+#define RUN_SAT_U_TRUNC_FMT_1_WRAP(NT, WT, x) RUN_SAT_U_TRUNC_FMT_1(NT, WT, x)
 
-#define RUN_SAT_U_TRUC_FMT_2(NT, WT, x) sat_u_truc_##WT##_to_##NT##_fmt_2 (x)
-#define RUN_SAT_U_TRUC_FMT_2_WRAP(NT, WT, x) RUN_SAT_U_TRUC_FMT_2(NT, WT, x)
+#define RUN_SAT_U_TRUNC_FMT_2(NT, WT, x) sat_u_trunc_##WT##_to_##NT##_fmt_2 (x)
+#define RUN_SAT_U_TRUNC_FMT_2_WRAP(NT, WT, x) RUN_SAT_U_TRUNC_FMT_2(NT, WT, x)
 
-#define RUN_SAT_U_TRUC_FMT_3(NT, WT, x) sat_u_truc_##WT##_to_##NT##_fmt_3 (x)
-#define RUN_SAT_U_TRUC_FMT_3_WRAP(NT, WT, x) RUN_SAT_U_TRUC_FMT_3(NT, WT, x)
+#define RUN_SAT_U_TRUNC_FMT_3(NT, WT, x) sat_u_trunc_##WT##_to_##NT##_fmt_3 (x)
+#define RUN_SAT_U_TRUNC_FMT_3_WRAP(NT, WT, x) RUN_SAT_U_TRUNC_FMT_3(NT, WT, x)
 
 #endif
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-1.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-1.c
index 354831005b5..84836070411 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-1.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-1.c
@@ -5,13 +5,13 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint16_t_to_uint8_t_fmt_1:
+** sat_u_trunc_uint16_t_to_uint8_t_fmt_1:
 ** sltiu\s+[atx][0-9]+,\s*a0,\s*255
 ** addi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*-1
 ** or\s+[atx][0-9]+,\s*[atx][0-9]+,\s*[atx][0-9]+
 ** andi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*0xff
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_1(uint8_t, uint16_t)
+DEF_SAT_U_TRUNC_FMT_1(uint8_t, uint16_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-13.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-13.c
index 58910793a80..060350ada45 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-13.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-13.c
@@ -5,13 +5,13 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint16_t_to_uint8_t_fmt_3:
+** sat_u_trunc_uint16_t_to_uint8_t_fmt_3:
 ** sltiu\s+[atx][0-9]+,\s*a0,\s*255
 ** addi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*-1
 ** or\s+[atx][0-9]+,\s*[atx][0-9]+,\s*[atx][0-9]+
 ** andi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*0xff
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_3(uint8_t, uint16_t)
+DEF_SAT_U_TRUNC_FMT_3(uint8_t, uint16_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-14.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-14.c
index 236ea1d45f7..a21c40c26c6 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-14.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-14.c
@@ -5,7 +5,7 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint32_t_to_uint16_t_fmt_3:
+** sat_u_trunc_uint32_t_to_uint16_t_fmt_3:
 ** li\s+[atx][0-9]+,\s*65536
 ** addi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*-1
 ** sltu\s+[atx][0-9]+,\s*a0,\s*[atx][0-9]+
@@ -15,6 +15,6 @@
 ** srli\s+a0,\s*a0,\s*48
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_3(uint16_t, uint32_t)
+DEF_SAT_U_TRUNC_FMT_3(uint16_t, uint32_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-15.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-15.c
index 33c3686c053..229371f1c5e 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-15.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-15.c
@@ -5,7 +5,7 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint64_t_to_uint32_t_fmt_3:
+** sat_u_trunc_uint64_t_to_uint32_t_fmt_3:
 ** li\s+[atx][0-9]+,\s*-1
 ** srli\s+[atx][0-9]+,\s*[atx][0-9]+,\s*32
 ** sltu\s+[atx][0-9]+,\s*a0,\s*[atx][0-9]+
@@ -14,6 +14,6 @@
 ** sext.w\s+a0,\s*a0
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_3(uint32_t, uint64_t)
+DEF_SAT_U_TRUNC_FMT_3(uint32_t, uint64_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-2.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-2.c
index 0001d8a9ed9..68d4e56c1f3 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-2.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-2.c
@@ -5,7 +5,7 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint32_t_to_uint16_t_fmt_1:
+** sat_u_trunc_uint32_t_to_uint16_t_fmt_1:
 ** li\s+[atx][0-9]+,\s*65536
 ** addi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*-1
 ** sltu\s+[atx][0-9]+,\s*a0,\s*[atx][0-9]+
@@ -15,6 +15,6 @@
 ** srli\s+a0,\s*a0,\s*48
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_1(uint16_t, uint32_t)
+DEF_SAT_U_TRUNC_FMT_1(uint16_t, uint32_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-3.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-3.c
index 4359935a9d7..a77f4d3fdbe 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-3.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-3.c
@@ -5,7 +5,7 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint64_t_to_uint32_t_fmt_1:
+** sat_u_trunc_uint64_t_to_uint32_t_fmt_1:
 ** li\s+[atx][0-9]+,\s*-1
 ** srli\s+[atx][0-9]+,\s*[atx][0-9]+,\s*32
 ** sltu\s+[atx][0-9]+,\s*a0,\s*[atx][0-9]+
@@ -14,6 +14,6 @@
 ** sext.w\s+a0,\s*a0
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_1(uint32_t, uint64_t)
+DEF_SAT_U_TRUNC_FMT_1(uint32_t, uint64_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-4.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-4.c
index 7d84b2689ce..f16af46294f 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-4.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-4.c
@@ -5,13 +5,13 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint32_t_to_uint8_t_fmt_1:
+** sat_u_trunc_uint32_t_to_uint8_t_fmt_1:
 ** sltiu\s+[atx][0-9]+,\s*a0,\s*255
 ** addi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*-1
 ** or\s+[atx][0-9]+,\s*[atx][0-9]+,\s*[atx][0-9]+
 ** andi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*0xff
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_1(uint8_t, uint32_t)
+DEF_SAT_U_TRUNC_FMT_1(uint8_t, uint32_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-5.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-5.c
index 87e6c649fbb..f54be149528 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-5.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-5.c
@@ -5,13 +5,13 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint64_t_to_uint8_t_fmt_1:
+** sat_u_trunc_uint64_t_to_uint8_t_fmt_1:
 ** sltiu\s+[atx][0-9]+,\s*a0,\s*255
 ** addi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*-1
 ** or\s+[atx][0-9]+,\s*[atx][0-9]+,\s*[atx][0-9]+
 ** andi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*0xff
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_1(uint8_t, uint64_t)
+DEF_SAT_U_TRUNC_FMT_1(uint8_t, uint64_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-6.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-6.c
index af410916fb2..04d55b6df9f 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-6.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-6.c
@@ -5,7 +5,7 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint64_t_to_uint16_t_fmt_1:
+** sat_u_trunc_uint64_t_to_uint16_t_fmt_1:
 ** li\s+[atx][0-9]+,\s*65536
 ** addi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*-1
 ** sltu\s+[atx][0-9]+,\s*a0,\s*[atx][0-9]+
@@ -15,6 +15,6 @@
 ** srli\s+a0,\s*a0,\s*48
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_1(uint16_t, uint64_t)
+DEF_SAT_U_TRUNC_FMT_1(uint16_t, uint64_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-7.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-7.c
index 95d513a15fb..5ecd6a835a5 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-7.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-7.c
@@ -5,13 +5,13 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint16_t_to_uint8_t_fmt_2:
+** sat_u_trunc_uint16_t_to_uint8_t_fmt_2:
 ** sltiu\s+[atx][0-9]+,\s*a0,\s*255
 ** addi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*-1
 ** or\s+[atx][0-9]+,\s*[atx][0-9]+,\s*[atx][0-9]+
 ** andi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*0xff
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_2(uint8_t, uint16_t)
+DEF_SAT_U_TRUNC_FMT_2(uint8_t, uint16_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-8.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-8.c
index f168912293d..f88965f2065 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-8.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-8.c
@@ -5,7 +5,7 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint32_t_to_uint16_t_fmt_2:
+** sat_u_trunc_uint32_t_to_uint16_t_fmt_2:
 ** li\s+[atx][0-9]+,\s*65536
 ** addi\s+[atx][0-9]+,\s*[atx][0-9]+,\s*-1
 ** sltu\s+[atx][0-9]+,\s*a0,\s*[atx][0-9]+
@@ -15,6 +15,6 @@
 ** srli\s+a0,\s*a0,\s*48
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_2(uint16_t, uint32_t)
+DEF_SAT_U_TRUNC_FMT_2(uint16_t, uint32_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-9.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-9.c
index d82363d6aef..a77efb1ce92 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-9.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-9.c
@@ -5,7 +5,7 @@
 #include "sat_arith.h"
 
 /*
-** sat_u_truc_uint64_t_to_uint32_t_fmt_2:
+** sat_u_trunc_uint64_t_to_uint32_t_fmt_2:
 ** li\s+[atx][0-9]+,\s*-1
 ** srli\s+[atx][0-9]+,\s*[atx][0-9]+,\s*32
 ** sltu\s+[atx][0-9]+,\s*a0,\s*[atx][0-9]+
@@ -14,6 +14,6 @@
 ** sext.w\s+a0,\s*a0
 ** ret
 */
-DEF_SAT_U_TRUC_FMT_2(uint32_t, uint64_t)
+DEF_SAT_U_TRUNC_FMT_2(uint32_t, uint64_t)
 
 /* { dg-final { scan-rtl-dump-times ".SAT_TRUNC " 2 "expand" } } */
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-1.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-1.c
index 39a5ce2b675..adaa421b239 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-1.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-1.c
@@ -7,10 +7,10 @@
 #define T1 uint8_t
 #define T2 uint16_t
 
-DEF_SAT_U_TRUC_FMT_1_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_1_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_1_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_1_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-13.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-13.c
index 6322305c5ed..7011e5040c5 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-13.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-13.c
@@ -7,10 +7,10 @@
 #define T1 uint8_t
 #define T2 uint16_t
 
-DEF_SAT_U_TRUC_FMT_3_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_3_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_3_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_3_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-14.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-14.c
index a29e887aeeb..8952c06fcc9 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-14.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-14.c
@@ -7,10 +7,10 @@
 #define T1 uint16_t
 #define T2 uint32_t
 
-DEF_SAT_U_TRUC_FMT_3_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_3_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_3_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_3_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-15.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-15.c
index a29e887aeeb..8952c06fcc9 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-15.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-15.c
@@ -7,10 +7,10 @@
 #define T1 uint16_t
 #define T2 uint32_t
 
-DEF_SAT_U_TRUC_FMT_3_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_3_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_3_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_3_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-2.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-2.c
index b98114a7dfc..a5f43e93a8d 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-2.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-2.c
@@ -7,10 +7,10 @@
 #define T1 uint16_t
 #define T2 uint32_t
 
-DEF_SAT_U_TRUC_FMT_1_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_1_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_1_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_1_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-3.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-3.c
index 8a92a8c1f55..a76ae0848da 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-3.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-3.c
@@ -7,10 +7,10 @@
 #define T1 uint32_t
 #define T2 uint64_t
 
-DEF_SAT_U_TRUC_FMT_1_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_1_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_1_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_1_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-4.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-4.c
index 609f3540555..d05ea792409 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-4.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-4.c
@@ -7,10 +7,10 @@
 #define T1 uint8_t
 #define T2 uint32_t
 
-DEF_SAT_U_TRUC_FMT_1_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_1_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_1_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_1_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-5.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-5.c
index 8629b3e956e..4fbdc9159cd 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-5.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-5.c
@@ -7,10 +7,10 @@
 #define T1 uint8_t
 #define T2 uint64_t
 
-DEF_SAT_U_TRUC_FMT_1_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_1_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_1_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_1_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-6.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-6.c
index 6d25869d239..38fcba3749c 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-6.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-6.c
@@ -7,10 +7,10 @@
 #define T1 uint16_t
 #define T2 uint64_t
 
-DEF_SAT_U_TRUC_FMT_1_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_1_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_1_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_1_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-7.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-7.c
index b98d40fa7ec..93705f97293 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-7.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-7.c
@@ -7,10 +7,10 @@
 #define T1 uint8_t
 #define T2 uint16_t
 
-DEF_SAT_U_TRUC_FMT_2_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_2_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_2_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_2_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-8.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-8.c
index 486585df7b8..c1164843df9 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-8.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-8.c
@@ -7,10 +7,10 @@
 #define T1 uint16_t
 #define T2 uint32_t
 
-DEF_SAT_U_TRUC_FMT_2_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_2_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_2_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_2_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"
diff --git a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-9.c b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-9.c
index 2099304a0be..4142e8727bd 100644
--- a/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-9.c
+++ b/gcc/testsuite/gcc.target/riscv/sat_u_trunc-run-9.c
@@ -7,10 +7,10 @@
 #define T1 uint32_t
 #define T2 uint64_t
 
-DEF_SAT_U_TRUC_FMT_2_WRAP(T1, T2)
+DEF_SAT_U_TRUNC_FMT_2_WRAP(T1, T2)
 
 #define DATA           TEST_UNARY_DATA_WRAP(T1, T2)
 #define T              TEST_UNARY_STRUCT_DECL(T1, T2)
-#define RUN_UNARY(x)   RUN_SAT_U_TRUC_FMT_2_WRAP(T1, T2, x)
+#define RUN_UNARY(x)   RUN_SAT_U_TRUNC_FMT_2_WRAP(T1, T2, x)
 
 #include "scalar_sat_unary.h"